#include "Liste.h"

//constructeur... Initialise la liste :
Liste::Liste(){
	this->tete=NULL;
};

void Liste::ajout(int nb){
	//si la liste est vide, on ajoute au dbut :
	if(estVide()){
		this->tete=new Noeud(nb);
	}else{
		//si la liste contient des lments, il faut aller jusqu'au dernier...
		//on commence du dbut, donc on initialise iter  tete :
		Noeud *iter=this->tete;
		//on parcourt la liste pour arriver jusqu'au dernier :
		while(iter->suivant!=NULL){
			iter=iter->suivant;
		}
		//iter pointe sur la dernire case...
		//il suffit d'ajouter la nouvelle valeur au bout du chainage :
		iter->suivant=new Noeud(nb);
		//il faut aussi mettre  jours le chainage dans l'autre sens :
		//iter->suivant dsigne la dernire case : c'est la "sous-case" precedent de cette dernire case qu'il faut modifier :
		iter->suivant->precedant=iter;
	}
};

bool Liste::estVide(){
	return this->tete==NULL;
};

void Liste::affiche(){
	//On va parcourir la liste et afficher chaque case une par une...
	//on commence du dbut, donc on initialise iter  tete :
	Noeud *iter=this->tete;
	//on parcourt la liste pour arriver jusqu'au dernier :
	while(iter->suivant!=NULL){
		cout<<iter->nombre<<" -> ";
		iter=iter->suivant;
	}
	//on affiche la dernire case :
	cout<<iter->nombre<<endl;
};

bool Liste::appartient(int nb){
	//On va parcourir la liste et tester chaque case une par une...
	//on commence du dbut, donc on initialise iter  tete :
	Noeud *iter=this->tete;
	//on parcourt la liste pour arriver jusqu'au dernier :
	while(iter!=NULL){
		//si la case sur laquel iter pointe contient le mme nombre que le paramtre, on renvoie vrai :
		if(iter->nombre==nb)
			return true;
		else{
			//sinon, on passe  la case suivante et on recommence...
			iter=iter->suivant;
		}
	}
	//si on est arriv jusqu'ici, c'est que l'on a pas trouv le nombre
	//on renvoie donc false (faux) :
	return false;
};